<?php

if (!defined('TYPO3_MODE')) {
	die('Access denied.');
}

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile(
	'sg_news', 'Configuration/TypoScript/Frontend', 'News System'
);

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	'sg_news', 'Overview',
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:titleOverviewPlugin'
);

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	'sg_news', 'Latest',
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:titleLatestPlugin'
);

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	'sg_news', 'SingleView',
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:titleSingleViewPlugin'
);

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	'sg_news', 'ListByCategory',
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:titleListByCategoryPlugin'
);

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	'sg_news', 'PageBrowser',
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:titlePageBrowserPlugin'
);

// Flex form assignment
$pluginSignature = str_replace('_', '', 'sg_news') . '_overview';
$TCA['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
	$pluginSignature, 'FILE:EXT:sg_news/Configuration/FlexForms/Overview.xml'
);

$pluginSignature = str_replace('_', '', 'sg_news') . '_listbycategory';
$TCA['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
	$pluginSignature, 'FILE:EXT:sg_news/Configuration/FlexForms/ListByCategory.xml'
);

$pluginSignature = str_replace('_', '', 'sg_news') . '_latest';
$TCA['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
	$pluginSignature, 'FILE:EXT:sg_news/Configuration/FlexForms/Latest.xml'
);

###################################
### Define the Category Doktype ###
###################################

$relativeExtensionPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath('sg_news');
$customPageDoktype = 117;
$customPageIcon = $relativeExtensionPath . 'Resources/Public/Images/Category.png';

// add the new doktype to the list of page types
$GLOBALS['PAGES_TYPES'][$customPageDoktype] = [
	'type' => 'sys',
	'icon' => $customPageIcon,
	'allowedTables' => '*',
];

// add the new doktype to the page type selector
$GLOBALS['TCA']['pages']['columns']['doktype']['config']['items'][] = [
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:pageType.category',
	$customPageDoktype,
	$customPageIcon
];

// also add the new doktype to the page language overlays type selector (so that translations can inherit the same type)
$GLOBALS['TCA']['pages_language_overlay']['columns']['doktype']['config']['items'][] = [
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:pageType.category',
	$customPageDoktype,
	$customPageIcon
];

// add the sprite icon for the new doktype
\TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $customPageDoktype, $customPageIcon);

// add the new doktype to the list of types available from the new page menu at the top of the page tree
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addUserTSConfig(
	'options.pageTree.doktypesToShowInNewPageDragArea := addToList(' . $customPageDoktype . ')'
);

###############################
### Define the News Doktype ###
###############################

$relativeExtensionPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath('sg_news');
$customPageDoktype = 116;
$customPageIcon = $relativeExtensionPath . 'Resources/Public/Images/News.png';

// add the new doktype to the list of page types
$GLOBALS['PAGES_TYPES'][$customPageDoktype] = [
	'type' => 'sys',
	'icon' => $customPageIcon,
	'allowedTables' => '*',
];

// add the new doktype to the page type selector
$GLOBALS['TCA']['pages']['columns']['doktype']['config']['items'][] = [
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:pageType.news',
	$customPageDoktype,
	$customPageIcon
];

// also add the new doktype to the page language overlays type selector (so that translations can inherit the same type)
$GLOBALS['TCA']['pages_language_overlay']['columns']['doktype']['config']['items'][] = [
	'LLL:EXT:sg_news/Resources/Private/Language/locallang_backend.xlf:pageType.news',
	$customPageDoktype,
	$customPageIcon
];

// add the sprite icon for the new doktype
\TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $customPageDoktype, $customPageIcon);

// add the new doktype to the list of types available from the new page menu at the top of the page tree
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addUserTSConfig(
	'options.pageTree.doktypesToShowInNewPageDragArea := addToList(' . $customPageDoktype . ')'
);

// Removal of the unused plugin setting fields
$TCA['tt_content']['types']['list']['subtypes_excludelist']['sgnews_overview'] = 'select_key,pages,recursive';
$TCA['tt_content']['types']['list']['subtypes_excludelist']['sgnews_listbycategory'] = 'select_key,pages,recursive';
$TCA['tt_content']['types']['list']['subtypes_excludelist']['sgnews_latest'] = 'select_key,pages,recursive';

?>
